// Learn TypeScript:
//  - https://docs.cocos.com/creator/manual/en/scripting/typescript.html
// Learn Attribute:
//  - https://docs.cocos.com/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - https://docs.cocos.com/creator/manual/en/scripting/life-cycle-callbacks.html

const {ccclass, property} = cc._decorator;

@ccclass
export default class NewClass extends cc.Component {
    rigidBody: cc.RigidBody;

    // LIFE-CYCLE CALLBACKS:

    onPreSolve(contact, selfCollider, otherCollider) {
        this.scheduleOnce(() => {
            this.rigidBody.type = cc.RigidBodyType.Kinematic;
        }, 0);
        this.rigidBody.linearVelocity = cc.v2(0, -otherCollider.node.getComponent(cc.RigidBody).angularVelocity);

    }
    onPostSolve(contact, selfCollider, otherCollider) {
        this.rigidBody.linearVelocity = cc.v2(0, 0);
    }
        
    onLoad () {
        this.rigidBody = this.node.getComponent(cc.RigidBody);
        this.rigidBody.type = cc.RigidBodyType.Dynamic;
    }

    start () {

    }

    // update (dt) {}
}
